package fi.em.formPlugin;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.exception.KDBizException;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.operate.botp.Draw;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.sdk.plugin.Plugin;

public class BusinessProcessingUnAuditEditPlugin  extends AbstractListPlugin implements Plugin {
    public static String deleteentryys = "deleteentryys"; //冲应收挂账
    //业务处理单基础资料选单过滤插件
    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        if (args.getSource() instanceof Draw) {
            Draw draw = (Draw) args.getSource();
            if (draw.getOperateKey().equals("drawysgz")) {
                Object nckd_orgv = this.getModel().getValue("nckd_orgfield");//获取当前单据付款人
                DynamicObject orgv = (DynamicObject) nckd_orgv;
                if ( orgv== null) {
                    throw new KDBizException("核算组织为空！");
                }

                String nckdItemclasstypefield1 = this.getModel().getValue("nckd_itemclasstypefield1").toString();//基础资料类型
                draw.getOption().setVariableValue("billtype", nckdItemclasstypefield1);
                DynamicObjectCollection nckdEntryentity1 = this.getModel().getEntryEntity("nckd_entryentity1");
                JSONArray jSONArray = new JSONArray();
                for(int i=0;i<nckdEntryentity1.size();i++){
                    JSONObject jsonObject = new JSONObject();
                    DynamicObject dynamicObject1 = nckdEntryentity1.get(i);
                    String nckdTextfield7 = dynamicObject1.getString("nckd_textfield7");
                    jsonObject.put("id",nckdTextfield7);
                    jSONArray.add(jsonObject);
                }
                draw.getOption().setVariableValue("JSONArray", jSONArray.toString());
                String orgnumber = orgv.getString("number");
                draw.getOption().setVariableValue("orgnumber", orgnumber);
                draw.getOption().setVariableValue("type", "drawysgz");
            } else if (draw.getOperateKey().equals("drawyfgz")) {
                Object value = this.getModel().getValue("nckd_payeenamevs");//获取当前单据付款人
                Object nckd_orgvs = this.getModel().getValue("nckd_orgfield");//获取当前单据收款人
                DynamicObject dynamicObject = (DynamicObject) value;
                DynamicObject orgvs = (DynamicObject) nckd_orgvs;
                if (dynamicObject == null) {
                    throw new KDBizException("核算组织为空！");
                }
                if (orgvs == null) {
                    throw new KDBizException("付款信息付款人为空！");
                }
                String nckdItemclasstypefield1 = this.getModel().getValue("nckd_itemclasstypefield").toString();//基础资料类型
                draw.getOption().setVariableValue("billtype", nckdItemclasstypefield1);
                DynamicObjectCollection nckdEntryentity1 = this.getModel().getEntryEntity("nckd_entryentity2");
                JSONArray jSONArray = new JSONArray();
                for(int i=0;i<nckdEntryentity1.size();i++){
                    JSONObject jsonObject = new JSONObject();
                    DynamicObject dynamicObject1 = nckdEntryentity1.get(i);
                    String nckdTextfield7 = dynamicObject1.getString("nckd_bigintfield");
                    jsonObject.put("id",nckdTextfield7);
                    jSONArray.add(jsonObject);
                }
                draw.getOption().setVariableValue("JSONArray", jSONArray.toString());
                String bdsupplier = dynamicObject.getString("id");//当前单据付款供应商
                draw.getOption().setVariableValue("bdsupplier", bdsupplier);
                String orgnumber = orgvs.getString("number");
                draw.getOption().setVariableValue("orgnumber", orgnumber);
                draw.getOption().setVariableValue("type", "drawyfgz");
            }else if (draw.getOperateKey().equals("drawzlht")) {
                Object value = this.getModel().getValue("nckd_orgfield");//获取当前单据核算组织
                Object nckd_payeenamevs = this.getModel().getValue("nckd_payeenamev");//获取当前单据付款人
                DynamicObject dynamicObject = (DynamicObject) value;
                DynamicObject payeenamevs = (DynamicObject) nckd_payeenamevs;
                if (dynamicObject == null) {
                    throw new KDBizException("核算组织为空！");
                }
                if (payeenamevs == null) {
                    throw new KDBizException("收款信息付款人为空！");
                }
                String nckdItemclasstypefield1 = this.getModel().getValue("nckd_itemclasstypefield1").toString();//基础资料类型
                draw.getOption().setVariableValue("billtype", nckdItemclasstypefield1);
                DynamicObjectCollection nckdEntryentity1 = this.getModel().getEntryEntity("nckd_entryentity3");
                JSONArray jSONArray = new JSONArray();
                for(int i=0;i<nckdEntryentity1.size();i++){
                    JSONObject jsonObject = new JSONObject();
                    DynamicObject dynamicObject1 = nckdEntryentity1.get(i);
                    String nckdTextfield7 = dynamicObject1.getString("nckd_pzhthth");
                    jsonObject.put("id",nckdTextfield7);
                    jSONArray.add(jsonObject);
                }
                draw.getOption().setVariableValue("JSONArray", jSONArray.toString());
                String bdsupplier = payeenamevs.getString("number");//当前单据付款供应商
                draw.getOption().setVariableValue("bdsupplier", bdsupplier);
                String orgnumber = dynamicObject.getString("number");
                draw.getOption().setVariableValue("orgnumber", orgnumber);
                draw.getOption().setVariableValue("type", "drawzlht");
            }else if (draw.getOperateKey().equals("draw-ssysd")) {
                //诉讼核销
                Object values = this.getModel().getValue("nckd_customers");//获取当前诉讼客户
                DynamicObject dynamicObjects = (DynamicObject) values;
                if (dynamicObjects == null) {
                    throw new KDBizException("单头诉讼客户为空！");
                }
                DynamicObjectCollection nckdEntryentity1 = this.getModel().getEntryEntity("nckd_entryentity11");
                JSONArray jSONArray = new JSONArray();
                for(int i=0;i<nckdEntryentity1.size();i++){
                    JSONObject jsonObject = new JSONObject();
                    DynamicObject dynamicObject1 = nckdEntryentity1.get(i);
                    String nckdTextfield7 = dynamicObject1.getString("nckd_textfield21");
                    jsonObject.put("id",nckdTextfield7);
                    jSONArray.add(jsonObject);
                }
                String customersid = dynamicObjects.getString("id");//当前单据付款供应商
                draw.getOption().setVariableValue("orgnumber", customersid);
                draw.getOption().setVariableValue("customersid", customersid);
                draw.getOption().setVariableValue("JSONArray", jSONArray.toString());
                draw.getOption().setVariableValue("type", "draw-ssysd");
            }else if (draw.getOperateKey().equals("draw-clyf")) {
                //诉讼核销
                Object values = this.getModel().getValue("applier");//获取当前单据报销人
                DynamicObject dynamicObjects = (DynamicObject) values;
                if (dynamicObjects == null) {
                    throw new KDBizException("报销人为空！");
                }
                DynamicObjectCollection nckdEntryentity1 = this.getModel().getEntryEntity("nckd_clearloanentry");
                JSONArray jSONArray = new JSONArray();
                for(int i=0;i<nckdEntryentity1.size();i++){
                    JSONObject jsonObject = new JSONObject();
                    DynamicObject dynamicObject1 = nckdEntryentity1.get(i);
                    String nckdTextfield7 = dynamicObject1.getString("nckd_billno");
                    jsonObject.put("id",nckdTextfield7);
                    jSONArray.add(jsonObject);
                }
                String userid = dynamicObjects.getString("id");//当前单据报销人id
                draw.getOption().setVariableValue("userid", userid);
                draw.getOption().setVariableValue("orgnumber", userid);
                draw.getOption().setVariableValue("JSONArray", jSONArray.toString());
                draw.getOption().setVariableValue("type", "draw-clyf");
            }
        }
        super.beforeDoOperation(args);
    }
}
